;;; -*- Mode:Lisp; Syntax:Common-Lisp; Package:GA; Base:10; -*-
;;;
;;; ******************************
;;; *  PORTABLE AI LAB - UNI ZH  *
;;; ******************************
;;;
;;; Filename:   ga-make.cl
;;; Short Desc: Compile & load code & documentation for the ga-module
;;; Version:    1.0
;;; Status:     review
;;; Last Mod:   May 1991
;;; Author:     Nick Almassy
;;;
;;; Copyright (c) 1992 Istituto Dalle Molle (IDSIA), University of
;;; Zurich, Swiss Federal Institute of Technology Lausanne.
;;;
;;; Permission is granted to any individual or institution to use, copy,
;;; modify, and distribute this software, provided that this complete
;;; copyright and permission notice is maintained, intact, in all
;;; copies and supporting documentation.
;;;
;;; IDSIA provides this software "as is" without express or implied
;;; warranty.  
;;;

;;; Languages: - Sun Allegro Common Lisp Version 3.1.13.1
;;; --------------------------------------------------------------------------
;;; Change History:
;;; --------------------------------------------------------------------------

;;; ------------------------------------------------------------------------
;;; DEFINE PACKAGE
;;; ------------------------------------------------------------------------

(defpackage :ga (:use :common-lisp :pail-lib))
(in-package :ga)

;;; ------------------------------------------------------------------------
;;; PARAMETERS
;;; ------------------------------------------------------------------------

(defparameter *ga-path* (add-subdir *pail-path* "ga"))

;;; ------------------------------------------------------------------------
;;; LOAD
;;; ------------------------------------------------------------------------

;;; (ensure-loaded (add-path "acl-gin" (add-subdir *pail-path* "pail-lib")))
;;; gin is loaded without the function ensure-loaded in the .

(ensure-loaded (add-path "ga" *ga-path*))
(ensure-loaded (add-path "ga-functions" *ga-path*))
(ensure-loaded (add-path "ga-dialog" *ga-path*))

(format *standard-output* "~%GA routines loaded.")

;;; ==========================================================================
;;; END OF FILE
;;; ==========================================================================
