;;; -*- Mode: LISP; Package: GTRE-EXAMPLE; Syntax: Common-lisp; -*-
;;;
;;; *******************************************************
;;;
;;; PORTABLE AI LAB - EPFL
;;;
;;; *******************************************************
;;;
;;; Filename:   al-ex.lisp
;;; Short Desc: data for CLICHE
;;; Version:    1.0
;;; Status:     experimental
;;; Last Mod:   19.12.91 - Francois BACHMANN
;;; Authors:    Francois BACHMANN & Fatma FEKIH-AHMED
;;;
;;; -------------------------------------------------------


;;; =======================================================================
;;; PACKAGE DECLARATIONS
;;; =======================================================================

(in-package :gtre-example)

(import '(pail-lib::tre-example
	  gtre::rule
	  gtre::assert!
	  gtre::rassert!
	  gtre::retract!
	  gtre::rretract!
	  gtre::contradiction ))


;;; =======================================================================
;;; ASSERTIONS FOR AN AL-DEFICIENCY PATIENT
;;; =======================================================================

(assert! '(p-nh3 1169) 'gtre::GOD)
(assert! '(p-arg 27) 'gtre::GOD)
(assert! '(p-citr 693) 'gtre::GOD)
(assert! '(u-3-hy-prop 30) 'gtre::GOD)
(assert! '(u-3-hy-isov 60) 'gtre::GOD)
(assert! '(u-lact  4060) 'gtre::GOD)
(assert! '(u-meth-citr 1) 'gtre::GOD)
(assert! '(u-meth-mal 1) 'gtre::GOD) 
(assert! '(u-orot 268) 'gtre::GOD)
(assert! '(u-asa 8483) 'gtre::GOD)
(assert! '(u-homocyst 0) 'gtre::GOD)

;;; =======================================================================
;;; END OF FILE
;;; ======================================================================= 
